#include "utils.h"
#include "SprattusPass.h"

#include "llvm/IR/PassManager.h"
#include "llvm/Transforms/IPO/PassManagerBuilder.h"
#include "llvm/Transforms/Scalar.h"

namespace sprattus
{
static llvm::RegisterPass<SprattusPass>
    SymabsPassInst("sprattus",
                   "Enable optimizations using symbolic abstraction.", false,
                   false);

#ifdef REPL_SCCP
static void registerSprattusPass(const llvm::PassManagerBuilder&,
                                 llvm::PassManagerBase& PM)
{
    PM.add(llvm::createInstructionNamerPass());
    PM.add(new SprattusPass());
    PM.add(llvm::createAggressiveDCEPass());
    PM.add(llvm::createCFGSimplificationPass());
}

static llvm::RegisterStandardPasses
    RegisterSprattusPass(llvm::PassManagerBuilder::EP_SCCPRepl,
                         registerSprattusPass);
#endif

} // namespace sprattus
