/**
 * RUN: clang -c -emit-llvm %s -o %t1.clang.bc
 * RUN: opt -mem2reg -instnamer %t1.clang.bc -o %t1.bc
 * RUN: %extract_config %s > %t1.py
 * RUN: %sprinstrument -config %t1.py %t1.bc %t2.db %t2.bc
 * RUN: clang %t2.bc %rt_flags -o %t2
 * RUN: %t2
 * RUN: %spranalyze -mode=only-dynamic -function=foo %t2.bc | %probe_filter %t1.bc > %t2.post
 * RUN: grep 'probe1 = 0000000010101010000000001010101000000000101010100000000010101010' %t2.post
 *
 * RUN: %spranalyze -mode=full -function=foo %t2.bc | %probe_filter %t1.bc > %t3.post
 * RUN: grep -F 'probe1 = 00000000********00000000********00000000********00000000********' %t3.post
 *
 * CONFIG: config.FragmentDecomposition = {'Strategy': 'Body'}
 * CONFIG: config.AbstractDomain = BitMask.Single
 */
#include <stdint.h>

extern void sprattus_probe(int, ...);

uint64_t foo(uint8_t a)
{
    uint64_t x = a;
    x = x | (x << 32);
    x = x | (x << 16) | (x << 48);

    sprattus_probe(0, x);
    return x;
}

int main(void)
{
    foo(0xAA);
    return 0;
}
