; RUN: opt %s -o %t1.bc
; RUN: %sprinstrument -config all_serializable_domains %t1.bc %t2.db %t2.bc
; RUN: clang %t2.bc %rt_flags -o %t2
; RUN: %t2
; RUN: %spranalyze -mode=only-dynamic -function multiple_int %t2.bc > %t2.int
; RUN: %spranalyze -mode=only-dynamic -function multiple_int %t2.bc > %t2.void
;
; RUN: grep -F 'x -> [0, 1]' %t2.int
; RUN: grep -F 'x -> [0, 1]' %t2.void
; RUN: grep -F 'cond -> top' %t2.int
; RUN: grep -F 'cond -> top' %t2.void

define i32 @multiple_int(i32 %x) #0 {
start:
    %cond = icmp ne i32 %x, 0
    br i1 %cond, label %a, label %b
a:
    ret i32 0
b:
    ret i32 1
}

define void @multiple_void(i32 %x) #0 {
start:
    %cond = icmp ne i32 %x, 0
    br i1 %cond, label %a, label %b
a:
    ret void
b:
    ret void
}

define i32 @main(i32 %argc, i8** %argv) #0 {
start:
  call void @multiple_void(i32 0)
  call void @multiple_void(i32 1)
  %one = call i32 @multiple_int(i32 0)
  %zero = call i32 @multiple_int(i32 1)

  ; check that the results are still correct after instrumentation
  %c1 = icmp ne i32 %one, 1
  %c2 = icmp ne i32 %zero, 0
  %res1 = or i1 %c1, %c2
  %res32 = zext i1 %res1 to i32
  ret i32 %res32
}
