/**
 * RUN: clang -c -emit-llvm %s -o %t1.pre.bc
 * RUN: opt -mem2reg -instnamer %t1.pre.bc -o %t1.bc
 * RUN: %sprinstrument -config all_serializable_domains %t1.bc %t2.db %t2.bc
 * RUN: clang %t2.bc %rt_flags -o %t2
 * RUN: %t2
 * RUN: %spranalyze -mode=only-dynamic -where=everywhere -function foo %t2.bc | %probe_filter %t1.bc > %t2.post
 *
 * RUN: grep "probe1 =< probe2" %t2.post
 * RUN: grep "probe2 = probe1 + 0000000000000000000000000000000*" %t2.post
 * RUN: grep "N > probe1" %t2.post
 * RUN: grep "N >= probe2" %t2.post
 * RUN: grep -F "N -> [0, 10]" %t2.post
 * RUN: grep -F "probe1 -> [0, 9]" %t2.post
 * RUN: grep -F "probe2 -> [0, 10]" %t2.post
 */

#include <stdio.h>

extern void sprattus_probe(int, ...);

void foo(int N)
{
	int i = 0, j = 0;
	for (; i < N; i++)
	{
		if (i % 2 == 1)
			j += 2;

		sprattus_probe(0, i, j);
	}
}

int main(int argc, char** argv)
{
	foo(0);
	foo(1);
	foo(10);
	return 0;
}
