; based on:
; #include <stdint.h>
;
; uint8_t test(uint8_t x)
; {
;     int i = 0;
;     int res = 0;
;
;     if (x <= 0) {
;         x = 42;
;     }
;
;     while (i < x) {
;         i++;
;         res = 1;
;     }
;
;     return res;
; }
;
; RUN: opt -instnamer %s > %t1.bc
; RUN: %spranalyze -config=06_const_body %t1.bc | grep -e "one -> #x01"

define zeroext i8 @test(i8 zeroext %x) #0 {
entry:
  %cmp = icmp eq i8 %x, 0
  br i1 %cmp, label %leq_0, label %pre_header

leq_0:
  br label %pre_header

pre_header:
  %pos_x = phi i8 [ 42, %leq_0 ], [ %x, %entry ]
  br label %loop_header

loop_header:
  %res = phi i32 [ 0, %pre_header ], [ 1, %loop_body ]
  %i = phi i32 [ 0, %pre_header ], [ %iinc, %loop_body ]
  %tmp = zext i8 %pos_x to i32
  %cmp2 = icmp slt i32 %i, %tmp
  br i1 %cmp2, label %loop_body, label %exit

loop_body:
  %iinc = add nsw i32 %i, 1
  br label %loop_header

exit:
  %one = trunc i32 %res to i8
  ret i8 %one
}
