; RUN: %extract_config %s > %t1.py
; RUN: opt -instnamer %s > %t1.bc
; RUN: %spranalyze -not-in-ssa-form -config=%t1.py %t1.bc > %t2
; RUN: grep -E 'p -> top' %t2
; RUN: grep -E 'p1 -> region of size #x0000000000000004' %t2
; RUN: grep -E 'p2 -> region of size #x0000000000000020' %t2
; RUN: grep -E 'p3 -> region of size #x0000000000000010' %t2
; RUN: grep -E 'p4 -> top' %t2
; RUN: grep -E 'p5 -> top' %t2
; RUN: grep -E 'p6 -> top' %t2

; RUN: grep -E 'p1 -> definitely valid region' %t2
; RUN: grep -E 'p2 -> definitely valid region' %t2
; RUN: grep -E 'p3 -> definitely valid region' %t2
; RUN: grep -E 'p5 -> definitely invalid region' %t2
; RUN: grep -E 'p6 -> definitely invalid region' %t2

; CONFIG: config.MemoryModel = {'Variant': 'BlockModel'}
; CONFIG: config.FragmentDecomposition = {'Strategy': 'Body'}
; CONFIG: config.AbstractDomain = [globals()['ConstRegion'], globals()['ValidRegion']]

define i32 @test(i64 %n, i32* %p) {
bb:
  %p1 = alloca i32, i64 1
  %p2 = alloca i32, i64 8
  %p3 = getelementptr i32* %p2, i64 4
  %p4 = alloca i32, i64 %n
  %p5 = getelementptr i32* null, i64 0
  %p6 = getelementptr i32* null, i64 4
  %x1 = load i32* %p1
  %x2 = load i32* %p3
  %x = add i32 %x1, %x2
  ret i32 %x
}

