; RUN: %extract_config %s > %t1.py
; RUN: opt -instnamer %s > %t1.bc
; RUN: not %spranalyze -config=%t1.py -check-memsafety %t1.bc > %t2.log
; RUN: grep -F "Possibly invalid memory access to p at bb" %t2.log
; Note that this test might pass because of too rough overapproximation
; instead of sound freeing of stack memory after function returns

; CONFIG: config.ModuleContext = {'Recursive': True}
; CONFIG: config.MemoryModel = {'Variant': 'BlockModel'}
; CONFIG: config.FragmentDecomposition = {'Strategy': 'Body'}
; CONFIG: config.AbstractDomain = [globals()['MemRegion']]

define i32 @test() {
bb:
  %p = call i32* @foo(i64 12)
  %r = load i32* %p
  ret i32 %r
}

define i32* @foo(i64 %n) {
bb:
  %n_rem = urem i64 %n, 256
  %cmp = icmp ugt i64 %n_rem, 0
  %n_pos = select i1 %cmp, i64 %n_rem, i64 42
  %p = alloca i32, i64 %n_pos
  ret i32* %p
}
