; RUN: opt %s -o %t1.bc
; RUN: %extract_config %s > %t1.py
; RUN: %spranalyze -config=%t1.py %t1.bc > %t2.log
; RUN: grep 'i = k\|k = i' %t2.log

; CONFIG: config.FragmentDecomposition = {'Strategy': 'Body'}
; CONFIG: config.Analyzer = {'Incremental': False}
; CONFIG: config.AbstractDomain = [
; CONFIG:         NumRels.Unsigned,
; CONFIG:         NumRels(ParamStrategy.ConstOffsets()),
; CONFIG:         domains['BitMask/Single']
; CONFIG:     ]

define i32 @foo() #0 {
entry:
  br label %header

header:
  %k = phi i32 [ 0, %entry ], [ %k_plus_one, %increment ]
  %i = phi i32 [ 0, %entry ], [ %i_plus_one, %increment ]
  %i_lt_2 = icmp slt i32 %i, 2
  br i1 %i_lt_2, label %body, label %exit

body:
  %k_plus_one = add nsw i32 %k, 1
  br label %increment

increment:
  %i_plus_one = add nsw i32 %i, 1
  br label %header

exit:
  ret i32 %k
}
