; RUN: %extract_config %s > %t1.py
; RUN: opt -instnamer %s > %t1.bc
; RUN: %spranalyze -config=%t1.py -where=everywhere %t1.bc > %t2.log
; RUN: awk '{print >out}; /end:/{out="%t3.log"}; /^$/{out=/dev/null}' out=/dev/null %t2.log
; RUN: grep -e '\(one == what\)\|\(what == one\) : always TRUE' %t3.log
; RUN: grep -e '\(notone == what\)\|\(what == notone\) : always FALSE' %t3.log
; RUN: awk '{print >out}; /baz:/{out="%t4.log"}; /^$/{out=/dev/null}' out=/dev/null %t2.log
; RUN: grep -e '\(three == ref_three\)\|\(ref_three == three\) : always TRUE' %t4.log
; XFAIL: win32

; CONFIG: config.FragmentDecomposition = {'Strategy': 'Function'}
; CONFIG: config.AbstractDomain = [Equality(ParamStrategy.PackedPairs()), SimpleConstProp]

define i32 @test(i32 %arg, i1 %cond) #0 {
start:
    br label %foo

foo:
    %one = phi i32 [1, %start]
    %ref_three = phi i32 [3, %start]
    %notone = add i32 %one, 7
    %what = add i32 %notone, -7
    br i1 %cond, label %bar, label %baz

bar:
    %two = add i32 2, 0
    br label %end

baz:
    %three = add i32 3, 0
    br label %end


end:
    %tmp = phi i32 [%two, %bar], [%three, %baz]
    %res = add i32 %tmp, %what
    ret i32 %res

}
