; A variant of `conditional_phi` that uses vectors and doubles. Neither of
; these types is meant to be supported but the analysis must still return a
; sound result if they're present.
;
; RUN: opt -instnamer %s > %t1.bc
; RUN: %spranalyze -config=01_const_function %t1.bc > %t2
; RUN: grep 'seven -> #x00000007' %t2
; RUN: grep 'cond -> top' %t2

define i32 @test(<4 x double>* byval align 32 %vec_ptr) #0 {
    %vec = load <4 x double>* %vec_ptr
    %elem = extractelement <4 x double> %vec, i32 0
    %cond = fcmp ogt double %elem,  0.000000e+00
    br i1 %cond, label %left, label %right

left:
    %val_left = phi i32 [7, %0]
    br label %end

right:
    %val_right = phi i32 [7, %0]
    br label %end

end:
    %seven = phi i32 [%val_left, %left], [%val_right, %right]
    ret i32 %seven
}
