#! /bin/bash

if [ -z ${PREPLIB+x} ]
then
    echo "Please set the PREPLIB variable to the path of the libpreparation_pass.so library!"
    exit 1
fi

FILE=$1

if [ -z $FILE ]
then
    echo "No input file specified!"
    exit 1
fi

TMPBCFILE=$FILE.tmp.bc
BCFILE=$FILE.bc

CFLAGS="-O3 -fno-vectorize -w -g -m32"

echo "Compiling file \`$FILE\`..."

clang $CFLAGS -emit-llvm -c -o $TMPBCFILE $FILE

echo "Applying further LLVM passes..."
opt -load $PREPLIB -mem2reg -always-inline -instnamer -prep $TMPBCFILE > $BCFILE

echo "Cleaning temporary file..."
rm $TMPBCFILE

echo "Done."

exit 0
